<template>
  <Row class="stock-list-page">
    <Row v-if="displayToolList" class="list-tool-box">
      <i-col :lg="16" :md="16" class="tool-list">
        <slot></slot>
      </i-col>
      <i-col :lg="8" :md="8" v-if="hasSearchColumns" class="quick-search">
        <i-input v-model="search.value" @keyup.enter.native="searchEmitAction">
          <i-select v-model="search.column" class="search-column" slot="prepend" placeholder="">
            <i-option v-for="(option, index) in searchColumns" :key="index" :value="option.value">
              {{option.label}}
            </i-option>
          </i-select>
          <Button icon="ios-search" slot="append" @click.native="searchEmitAction"></Button>
        </i-input>
      </i-col>
    </Row>
    <Row class="list-body">
      <Table class="data-table" border stripe ref="selection" :columns="tableColumns" :data="tableData" size="large"
             @on-select="selectionEmitAction"
             @on-select-cancel="selectionEmitAction"
             @on-select-all="selectionEmitAction"
             @on-select-all-cancel="selectionEmitAction">
      </Table>
      <Row class=data-table-page>
        <Page :total="totalDataAmount"
              :current="search.pageAt"
              :page-size-opts="pageSizeOptions"
              :page-size="search.pageSize"
              show-sizer
              @on-change="pageChangedAction"
              @on-page-size-change="pageSizeChangedAction"/>
      </Row>
    </Row>
  </Row>
</template>

<script>
const actions = {
  searchEmitAction() {
    const defaultSearch = !this.search.value;
    if (defaultSearch) {
      this.$emit('search', {
        ...this.search,
        column: undefined,
        value: undefined
      });
    } else {
      this.$emit('search', this.search);
    }
  },
  pageChangedAction(pageAt) {
    this.search.pageAt = pageAt;
    this.searchEmitAction();
    this.$scrollToTop();
  },
  pageSizeChangedAction(pageSize) {
    this.search.pageAt = 1;
    this.search.pageSize = pageSize;
    this.searchEmitAction();
  },
  selectionEmitAction(selection, row) {
    this.$emit('selected', { selection, row });
  },
};

export default {
  name: 'stock-list-page',
  props: {
    displayToolList: {
      type: Boolean,
      default: true,
    },
    searchColumns: {
      type: Array,
      default: () => {
        return [];
      },
    },
    tableColumns: {
      type: Array,
      required: true,
    },
    tableData: {
      type: Array,
      default: () => {
        return [];
      },
    },
    totalDataAmount: {
      type: Number,
      default: 0,
    },
    pageSizeOptions: {
      type: Array,
      default: () => {
        return [10, 50, 100, 200, 500];
      },
    },
    defaultPageAt: { type: Number, default: 1 },
  },
  data() {
    return {
      search: {
        column: (this.searchColumns[0]) ? this.searchColumns[0].value : undefined,
        value: undefined,
        pageAt: this.defaultPageAt,
        pageSize: this.pageSizeOptions[0],
      },
    };
  },
  watch: {
    defaultPageAt() {
      this.search.pageAt = this.defaultPageAt;
    }
  },
  computed: {
    hasSearchColumns() {
      return this.searchColumns.length > 0;
    }
  },
  methods: {
    ...actions,
  },
}
</script>

<style lang="scss" scoped>
  .stock-list-page {
    padding-top: 40px;
    .list-tool-box {
      height: 60px;
      padding: 10px 80px;
      .tool-list {
        height: 100%;
      }
      .quick-search {
        height: 100%;
        .search-column {
          width: 120px;
        }
      }
    }
    .list-body {
      padding-left: 80px;
      padding-right: 80px;
      .data-table-page {
        margin: 40px 0;
        text-align: center;
      }
    }
  }
</style>
